#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */

void OnHosStart(VP_INT exinf)
{
	putStringSCI1("OnHosStart: starting!\n");
	act_tsk(tskID_A);
}


void TaskA(VP_INT exinf)
{
	ER ercd;
	putStringSCI1("TaskA: starting\n");

	putStringSCI1("TaskA: execuing act_tsk(tskID_B), 1st time\n");
	ercd=sta_tsk(tskID_B,1);
	if (ercd!=E_OK) putStringSCI1("TaskA: can't start TaskB, 1st time\n");
	putStringSCI1("TaskA: execuing act_tsk(tskID_B), 2nd time\n");
	ercd=sta_tsk(tskID_B,2);
	if (ercd!=E_OK) putStringSCI1("TaskA: can't start TaskB, 2nd time\n");

	ext_tsk();

}

void TaskB(VP_INT exinf)
{
	SCI1_printf("TaskB: starting %ld\n",exinf);
	ext_tsk();
}

/*
yPzTaskA̗D揇ʁTaskB̗D揇ʂ̎
system.cfg
                                                D揇
CRE_TSK(tskID_A,   {TA_HLNG         , 1, TaskA, 5, 256, NULL});
CRE_TSK(tskID_B,   {TA_HLNG         , 1, TaskB, 6, 256, NULL});

preStartHos: start!
OnHosStart: starting!
TaskA: starting
TaskA: execuing act_tsk(tskID_B), 1st time
TaskA: execuing act_tsk(tskID_B), 2nd time
TaskA: can't start TaskB, 2nd time
TaskB: starting 1

yQzTaskB̗D揇ʁTaskA̗D揇ʂ̎
system.cfg
                                                D揇
CRE_TSK(tskID_A,   {TA_HLNG         , 1, TaskA, 6, 256, NULL});
CRE_TSK(tskID_B,   {TA_HLNG         , 1, TaskB, 5, 256, NULL});

preStartHos: start!
OnHosStart: starting!
TaskA: starting
TaskA: execuing act_tsk(tskID_B), 1st time
TaskB: starting 1
TaskA: execuing act_tsk(tskID_B), 2nd time
TaskB: starting 2
*/

