#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	initLCD();               /* LCD̏ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

int isBusy=0; /*SCI̎gp*/
int number[4]={0,1,1,1}; /*\p*/

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */
void OnHosStart(VP_INT exinf)
{
	putStringSCI1("OnHosStart: starting!\n");
	LCDgotoxy(5,0);
	LCD_printf("** %d%d%d **",number[1],number[2],number[3]);
}

void CYC_wupCButton(VP_INT exinf)
{
	wup_tsk(tskID_CHK_BTN);
}

void checkButton(VP_INT exinf)
{
	static int oldbutton=0;
	int button;
	int stat;
/*
	T_RFLG pk_rflg;
*/
	putStringSCI1("checkButton: starting!\n");
	sta_cyc(cycID_CHK_BTN);
	while(1) {
		slp_tsk();
		button=getPushSW();
		/*SCI1_printf("%x",button);*/
		if ((stat=(oldbutton^button))) {
			if (oldbutton<button) { /*ꂽ*/
				stat=(stat<<1)+1;
			} else {
				stat=(stat<<1);
			}
			sta_tsk(tskID_BTN_HDL,stat);
			oldbutton=button;
		}
/*
		ref_flg(flgID,&pk_rflg);
		SCI1_printf("%d%d%d-%d\n",number[1],number[2],number[3],pk_rflg.flgptn);
*/
	}
	ext_tsk();
}

#define B0PUSH 0x03 /*0001 1*/
#define B0RELS 0x02 /*0001 0*/
#define B1PUSH 0x05 /*0010 1*/
#define B1RELS 0x04 /*0010 0*/
#define B2PUSH 0x09 /*0100 1*/
#define B2RELS 0x08 /*0100 0*/
#define B3PUSH 0x11 /*1000 1*/
#define B3RELS 0x10 /*1000 0*/


void buttonHandler(VP_INT exinf)
{
	T_RFLG pk_rflg;
	switch (exinf) {
	case B0PUSH:
		SCI1_printf("%d%d%d B0 PUSHED  \n",number[1],number[2],number[3]);
		ref_flg(flgID,&pk_rflg);
		if (pk_rflg.flgptn) clr_flg(flgID,~7);
		break;
	case B0RELS:
		SCI1_printf("%d%d%d B0 RELEASED\n",number[1],number[2],number[3]);
		set_flg(flgID,7);
		break;
	case B1PUSH:
		SCI1_printf("%d%d%d B1 PUSHED  \n",number[1],number[2],number[3]);
		clr_flg(flgID,~1);
		break;
	case B1RELS:
		SCI1_printf("%d%d%d B1 RELEASED\n",number[1],number[2],number[3]);
		break;
	case B2PUSH:
		SCI1_printf("%d%d%d B2 PUSHED  \n",number[1],number[2],number[3]);
		clr_flg(flgID,~2);
		break;
	case B2RELS:
		SCI1_printf("%d%d%d B2 RELEASED\n",number[1],number[2],number[3]);
		break;
	case B3PUSH:
		SCI1_printf("%d%d%d B3 PUSHED  \n",number[1],number[2],number[3]);
		clr_flg(flgID,~4);
		break;
	case B3RELS:
		SCI1_printf("%d%d%d B3 RELEASED\n",number[1],number[2],number[3]);
		break;
	default:
		break;
	}
	ext_tsk();
}

void drumTask(VP_INT exinf)
{
	const static int delaynumber[]={0,70,90,130};
	const static int flag[]={0,1,2,4};
	FLGPTN flgptn;
	SCI1_printf("drumTask(%ld): starting!\n",exinf);
	while(1) {
		wai_flg(flgID,flag[exinf],TWF_ANDW,&flgptn);
		number[exinf]++;
		if (number[exinf]==10) number[exinf]=1;
		if (!isBusy) {
			isBusy=1;
			/*SCI1_printf("%d%d%d-%d-%d%d\n",number[1],number[2],number[3],exinf,flag[exinf],flgptn);*/
			LCDgotoxy(5,0);
			LCD_printf("** %d%d%d **",number[1],number[2],number[3]);
			isBusy=0;
		}
		dly_tsk(delaynumber[exinf]);
	}
}

