#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

/*                                  D揇     */
T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 5, 256, NULL};
T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 6, 256, NULL};
ID tskID_A, tskID_B;

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */
void OnHosStart(VP_INT exinf)
{
	ER_ID tskid; /*ȂIDCȂG[R[h*/
	putStringSCI1("OnHosStart: starting!\n");
	tskid=acre_tsk(&pk_ctskA);
	if (E_OK<tskid) {
		tskID_A=tskid;
		SCI1_printf("Priority of TaskA = %d\n",pk_ctskA.itskpri);
	} else {
		SCI1_printf("acre_tsk A err %d\n",tskid);
	}
	tskid=acre_tsk(&pk_ctskB);
	if (E_OK<tskid) {
		tskID_B=tskid;
		SCI1_printf("Priority of TaskB = %d\n",pk_ctskB.itskpri);
	} else {
		SCI1_printf("acre_tsk B err %d\n",tskid);
	}
	act_tsk(tskID_A);
}

void TaskA(VP_INT exinf)
{
	ER ercd;
	putStringSCI1("TaskA: starting\n");

	putStringSCI1("TaskA: execuing act_tsk(tskID_B), 1st time\n");
	ercd=sta_tsk(tskID_B,1);
	if (ercd!=E_OK) putStringSCI1("TaskA: can't start TaskB, 1st time\n");
	putStringSCI1("TaskA: execuing act_tsk(tskID_B), 2nd time\n");
	ercd=sta_tsk(tskID_B,2);
	if (ercd!=E_OK) putStringSCI1("TaskA: can't start TaskB, 2nd time\n");

	ext_tsk();

}

void TaskB(VP_INT exinf)
{
	SCI1_printf("TaskB: starting %ld\n",exinf);
	ext_tsk();
}

/*
yPzTaskA̗D揇ʁTaskB̗D揇ʂ̎
                                   D揇
T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 5, 256, NULL};
T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 6, 256, NULL};

main: starting!
OnHosStart: starting!
TaskA: starting
TaskA: execuing act_tsk(tskID_B), 1st time
TaskA: execuing act_tsk(tskID_B), 2nd time
TaskA: can't start TaskB, 2nd time
TaskB: starting 1

yQzTaskB̗D揇ʁTaskA̗D揇ʂ̎
                                   D揇
T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 6, 256, NULL};
T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 5, 256, NULL};

main: starting!
OnHosStart: starting!
TaskA: starting
TaskA: execuing act_tsk(tskID_B), 1st time
TaskB: starting 1
TaskA: execuing act_tsk(tskID_B), 2nd time
TaskB: starting 2
*/

