#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */
void OnHosStart(VP_INT exinf)
{
	putStringSCI1("OnHosStart: starting!\n");
	act_tsk(tskID_CHK_BTN);
}

void CYC_wupCButton(VP_INT exinf)
{
	wup_tsk(tskID_CHK_BTN);
}

void checkButton(VP_INT exinf)
{
	static int oldbutton=0;
	int button;
	int stat;
	putStringSCI1("checkButton: starting!\n");
	sta_cyc(cycID_CHK_BTN);
	while(1) {
		slp_tsk();
		button=getPushSW();
		/*SCI1_printf("%x",button);*/
		if ((stat=(oldbutton^button))) {
			if (oldbutton<button) { /*ꂽ*/
				stat=(stat<<1)+1;
			} else {
				stat=(stat<<1);
			}
			sta_tsk(tskID_BTN_HDL,stat);
			oldbutton=button;
		}
	}
	ext_tsk();
}

#define B0PUSH 0x03 /*0001 1*/
#define B0RELS 0x02 /*0001 0*/
#define B1PUSH 0x05 /*0010 1*/
#define B1RELS 0x04 /*0010 0*/
#define B2PUSH 0x09 /*0100 1*/
#define B2RELS 0x08 /*0100 0*/
#define B3PUSH 0x11 /*1000 1*/
#define B3RELS 0x10 /*1000 0*/


void buttonHandler(VP_INT exinf)
{
	switch (exinf) {
	case B0PUSH:
		SCI1_printf("B0 PUSHED  \n");
		break;
	case B0RELS:
		SCI1_printf("B0 RELEASED\n");
		break;
	case B1PUSH:
		SCI1_printf("B1 PUSHED  \n");
		break;
	case B1RELS:
		SCI1_printf("B1 RELEASED\n");
		break;
	case B2PUSH:
		SCI1_printf("B2 PUSHED  \n");
		break;
	case B2RELS:
		SCI1_printf("B2 RELEASED\n");
		break;
	case B3PUSH:
		SCI1_printf("B3 PUSHED  \n");
		break;
	case B3RELS:
		SCI1_printf("B3 RELEASED\n");
		break;
	default:
		break;
	}
	ext_tsk();
}

