#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */
void OnHosStart(VP_INT exinf)
{
	putStringSCI1("OnHosStart: starting!\n");
	act_tsk(TSKID_0);
}

/*#define USE_SEMAPHO*/

#ifdef USE_SEMAPHO
/*semaphogpꍇ*/
void taskA(VP_INT exinf)
{
	int i;
	putStringSCI1("taskA: starting!\n");
	dly_tsk(2);
	act_tsk(TSKID_1);
	for (i=0;i<3;i++) {
		wai_sem(SEMID_SCI);
		putStringSCI1("taskA: Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!\n");
		sig_sem(SEMID_SCI);
	}
	ext_tsk();
}

void taskB(VP_INT exinf)
{
	int i;
	putStringSCI1("taskB: starting!\n");
	dly_tsk(2);
	for (i=0;i<10;i++) {
		wai_sem(SEMID_SCI);
		putStringSCI1("French beans\n");
		sig_sem(SEMID_SCI);
		dly_tsk(2);
	}
	ext_tsk();
}

#else
/*semaphogpȂꍇ*/
void taskA(VP_INT exinf)
{
	int i;
	putStringSCI1("taskA: starting!\n");
	dly_tsk(2);
	act_tsk(TSKID_1);
	for (i=0;i<3;i++) {
		putStringSCI1("Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!\n");
	}
	ext_tsk();
}

void taskB(VP_INT exinf)
{
	int i;
	putStringSCI1("taskB: starting!\n");
	dly_tsk(2);
	for (i=0;i<10;i++) {
		putStringSCI1("French beans\n");
		dly_tsk(2);
	}
	ext_tsk();
}

#endif

/*
iPjsemaphogpꍇ
#define USE_SEMAPHO@L

preStartHos: start!
OnHosStart: starting!
taskA: starting!
taskB: starting!
Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!
French beans
Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!
French beans
Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!
French beans
French beans
French beans
French beans
French beans
French beans
French beans
French beans

iQjsemaphogpȂꍇ
#define USE_SEMAPHO@RgAEg

preStartHos: start!
OnHosStart: starting!
taskA: starting!
taskB: starting!
Peter French beans
ran stFrench beans
raighFrench beans
t awayFrench beans
 to MrFrench beans
. McGFrench beans
regor'French beans
s garFrench beans
den, aFrench beans
nd sqFrench beans
ueezed under the gate!
Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!
Peter ran straight away to Mr. McGregor's garden, and squeezed under the gate!

*/
