# --------------------------------------------------------------------------- 
#  Hyper Operating System V4  TvvO                              
#    CNt@Cih8300-hms  GNUCRpCŁj                            
#                                                                             
#                                   Copyright (C) 1998-2002 by Project HOS    
#                                   http://sourceforge.jp/projects/hos/       
# --------------------------------------------------------------------------- 


# FreeBSD 4.6RtmakeAGNU make 3.79.1ɂēmFĂ܂B

#[UvÕ\[Xt@C
USRSRC = sample.c

# pX
#HOSROOT  = C:/hos-v4
HOSROOT  = C:/cygwin/usr/local/hos-v4
INCDIR   = $(HOSROOT)/include
PACDIR   = $(HOSROOT)/include/h83
LIBDIR   = $(HOSROOT)/lib/h83/gcc


# c[
CC     = h8300-hms-coff-gcc
CPP    = h8300-hms-coff-gcc
ASM    = h8300-hms-coff-gcc
LINK   = h8300-hms-coff-gcc
OBJCNV = h8300-hms-coff-objcopy -O srec
HOSCFG = $(HOSROOT)/config/hos4cfg


# IvV
CFLAGS   = -Os -Wall -I$(INCDIR) -I$(PACDIR) -mh -c -pipe
CPPFLAGS = -E -mh -x c
AFLAGS   = -mh -c
#LFLAGS   = -mh -nostartfiles -nostdlib -Wl,-Map,$(TARGET).map \
#		-Wl,-T$(LDSCRIPT) -L$(LIBDIR)
LFLAGS   = -mh -nostartfiles -Wl,-Map,$(TARGET).map \
		-Wl,-T$(LDSCRIPT) -L$(LIBDIR)
LIBS	 = -lgcc -lh4h83
# ^[Qbg
TARGET = $(USRSRC:.c=)

#CN[ht@C
INCS = kernel_id.h $(USRSRC:.c=.h) MinSys3052.h

#JXNvg
LDSCRIPT = h83052.x

# IuWFNgt@C ̍\`
OBJS = crt0.o vector.o kernel_cfg.o MinSys3052.o $(USRSRC:.c=.o)


# ^[QbgW[
$(TARGET).mot: $(OBJS) $(LDSCRIPT)
	$(LINK) $(LFLAGS) -o $(TARGET).coff $(OBJS) $(LIBS)
	$(OBJCNV) $(TARGET).coff $(TARGET).mot


# IuWFNg
kernel_cfg.o: kernel_cfg.c $(INCS)
	$(CC) $(CFLAGS) kernel_cfg.c

vector.o: vector.s
	$(ASM) $(AFLAGS) vector.s

crt0.o: crt0.s
	$(ASM) $(AFLAGS) crt0.s

$(USRSRC:.c=.o): $(USRSRC) $(INCS)
	$(CC) $(CFLAGS) $(USRSRC)

MinSys3052.o: MinSys3052.c $(INCS)
	$(CC) $(CFLAGS) MinSys3052.c

kernel_cfg.c kernel_id.h: system.cfg
	$(CPP) $(CPPFLAGS) system.cfg | $(HOSCFG) -

# tbV
write:
	h8write -3052 $(TARGET).mot
# /dev/cuaa0


# N[ibv
clean:
	rm  -f  $(TARGET).coff $(TARGET).mot $(TARGET).map \
		$(OBJS) kernel_id.h kernel_cfg.c *~


# --------------------------------------------------------------------------- 
#  Copyright (C) 1998-2002 by Project HOS                                     
# --------------------------------------------------------------------------- 
