#include "kernel.h"
#include "kernel_id.h"
#include "MinSys3052.h"
#include "sample.h"


/* X^[gAbv[`ŏɌĂяo鏉֐ */
/* OSNOɂ邱ƁiSCȈȂǁjsĂ      */
/* ̊֐X^[gAbv[`ɖ߂ɁC       */
/* X^[gAbv[`HOSĂяo                  */
void preStartHos()
{
	initSCI1();              /* SCȈ */
	SCI1_printf("\npreStartHos: start!\n");  /* JnbZ[W */
	initLed();               /* LED̏ */
	initPushSW();            /* PushSW̏*/
	init8BitSW();            /* 8bitSW̏ */
}

/*                                              D揇     */
const static T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 5, 256, NULL};
const static T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 5, 256, NULL};
const static T_CTSK pk_ctskC={TA_HLNG, 1, TaskC, 4, 256, NULL};
ID tskID_A, tskID_B, tskID_C;
const static T_CFLG pk_cflg={(TA_TFIFO | TA_WSGL),0};
ID flgID;

/* HOSōŏɋNnh*/
/* system.cfgŐÓIɋN */
void OnHosStart(VP_INT exinf)
{
	ER_ID tskid; /*ȂIDCȂG[R[h*/
	ER_ID flgid; /*ȂIDCȂG[R[h*/
	putStringSCI1("OnHosStart: starting!\n");
	
	tskid=acre_tsk(&pk_ctskA);
	if (E_OK<tskid) {
		tskID_A=tskid;
		SCI1_printf("OnHosStart: A Pri,id= %d,%d\n",pk_ctskA.itskpri,tskid);
	} else {
		SCI1_printf("OnHosStart: acre_tsk A err %d\n",tskid);
	}
	
	tskid=acre_tsk(&pk_ctskB);
	if (E_OK<tskid) {
		tskID_B=tskid;
		SCI1_printf("OnHosStart: B Pri,id= %d,%d\n",pk_ctskB.itskpri,tskid);
	} else {
		SCI1_printf("OnHosStart: acre_tsk B err %d\n",tskid);
	}
	
	tskid=acre_tsk(&pk_ctskC);
	if (E_OK<tskid) {
		tskID_C=tskid;
		SCI1_printf("OnHosStart: C Pri,id= %d,%d\n",pk_ctskC.itskpri,tskid);
	} else {
		SCI1_printf("OnHosStart: acre_tsk C err %d\n",tskid);
	}
	
	flgid=acre_flg(&pk_cflg);
	if (E_OK<flgid) {
		flgID=flgid;
		SCI1_printf("OnHosStart: flgid=%d\n",flgID);
	} else {
		SCI1_printf("OnHosStart: acre_flg err %d\n",flgid);
	}
	act_tsk(tskID_C);
	act_tsk(tskID_B);
	act_tsk(tskID_A);
}

void TaskA(VP_INT exinf)
{
	T_RFLG pk_rflg;
	SCI1_printf("TaskA: starting\n");
	ref_flg(flgID,&pk_rflg);
	SCI1_printf("TaskA: flgptn=%02x\n",pk_rflg.flgptn);
	set_flg(flgID,1);
	ref_flg(flgID,&pk_rflg);
	SCI1_printf("TaskA: flgptn=%02x\n",pk_rflg.flgptn);
	ext_tsk();
}

void TaskB(VP_INT exinf)
{
	T_RFLG pk_rflg;
	SCI1_printf("TaskB: starting\n");
	ref_flg(flgID,&pk_rflg);
	SCI1_printf("TaskB: flgptn=%02x\n",pk_rflg.flgptn);
	set_flg(flgID,2);
	ref_flg(flgID,&pk_rflg);
	SCI1_printf("TaskB: flgptn=%02x\n",pk_rflg.flgptn);
	ext_tsk();
}

void TaskC(VP_INT exinf)
{
	T_RFLG pk_rflg;
	FLGPTN flgptn;
	SCI1_printf("TaskC: starting\n");
	wai_flg(flgID,3,TWF_ANDW,&flgptn);
	SCI1_printf("TaskC: flgptn=%02x\n",flgptn);
	clr_flg(flgID,~3);
	ref_flg(flgID,&pk_rflg);
	SCI1_printf("TaskC: flgptn=%02x\n",pk_rflg.flgptn);
	ext_tsk();
}

/*
yPzTaskC̗D揇ʁTaskA,TaskB̗D揇ʂ̎
                                                D揇
const static T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 5, 256, NULL};
const static T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 5, 256, NULL};
const static T_CTSK pk_ctskC={TA_HLNG, 1, TaskC, 4, 256, NULL};

preStartHos: start!
OnHosStart: starting!
OnHosStart: A Pri,id= 5,8
OnHosStart: B Pri,id= 5,7
OnHosStart: C Pri,id= 4,6
OnHosStart: flgid=4
TaskC: starting
TaskB: starting
TaskB: flgptn=00
TaskB: flgptn=02
TaskA: starting
TaskA: flgptn=02
TaskC: flgptn=03
TaskC: flgptn=00
TaskA: flgptn=00

yQzTaskA,TaskB̗D揇ʁTaskC̗D揇ʂ̎
                                                D揇
const static T_CTSK pk_ctskA={TA_HLNG, 1, TaskA, 4, 256, NULL};
const static T_CTSK pk_ctskB={TA_HLNG, 1, TaskB, 4, 256, NULL};
const static T_CTSK pk_ctskC={TA_HLNG, 1, TaskC, 5, 256, NULL};

preStartHos: start!
OnHosStart: starting!
OnHosStart: A Pri,id= 4,8
OnHosStart: B Pri,id= 4,7
OnHosStart: C Pri,id= 5,6
OnHosStart: flgid=4
TaskB: starting
TaskB: flgptn=00
TaskB: flgptn=02
TaskA: starting
TaskA: flgptn=02
TaskA: flgptn=03
TaskC: starting
TaskC: flgptn=03
TaskC: flgptn=00
*/

